﻿var g_nameInternal = "FAYTGoAlias";
var g_defKey = "!";
var g_defBackColor = "#65a327";
var g_defTextColor = "#000000";

function OnInit(initData)
{
	initData.name = "FAYT Go Alias";
	initData.version = "0.1";
	initData.copyright = "(c) 2024 DeGandalf";
//	initData.url = "https://resource.dopus.com/c/buttons-scripts/16";
	initData.desc = "";
	initData.default_enable = true;
	initData.min_version = "13.0";
}

function OnAddCommands(addCmdData)
{
	var cmd = addCmdData.AddCommand();
	cmd.name = g_nameInternal;
	cmd.method = "OnFAYTSearch";
	cmd.desc = "";
	cmd.label = g_nameInternal;
	cmd.template = "";
	cmd.hide = true; // Hide from button editor menus
	cmd.icon = "script";

	var fayt = cmd.fayt;
	fayt.enable = true;
	fayt.key = g_defKey;
	fayt.backcolor = g_defBackColor;
	fayt.textcolor = g_defTextColor;
	fayt.label = "Go Alias";
//	fayt.flags - optional Map of flags (flag value -> label) - need to use DOpus.Create.Map
	fayt.realtime = true;
}

function OnFAYTSearch(scriptFAYTData)
{
	if (scriptFAYTData.fayt != g_nameInternal)
	{
		DOpus.Output('Unexpected FAYT: "' + scriptFAYTData.fayt + '"');
		return;
	}

	var DOpusFactory = DOpus.Create();

	var tab = scriptFAYTData.tab;
	var query = scriptFAYTData.cmdline;

	aliases = DOpus.aliases;
	var ownAliases = DOpus.Create.Map()
	for (var i = 0; i < aliases.count; i++) {
		var alias = aliases[i];
		if (!alias.system && BeginsWith(alias.name, query)) {
			ownAliases(alias.name) = alias.path;
		}
	}

	if (scriptFAYTData.key == "return")
	{
		if (ownAliases.exists(query))
		{
			var command = DOpusFactory.Command();
			command.RunCommand("Go /" + query);
			return;
		}
	}

	if (scriptFAYTData.suggest)
	{
		tab.UpdateFAYTSuggestions(ownAliases);
	}
	
	return;
}

function BeginsWith(container, query) {
	if (query.length > container.length) { return false; }

	for (var i = 0; i < query.length; i++) {
		if (query[i] != container[i]) {
			return false;
		}
	}

	return true;
}
